#!/bin/bash

export PYTHONPATH=$PYTHONPATH:.
SRC='src/tlp_rnn_fusion'

# Uncomment individual sections to run the experiment of fusion.

################## Fusion of RNN base models trained on MNIST dataset ###################

#### GWB Fusion ####

# SRC='src/tlp_rnn_fusion'
# seed=(847 53 43 348 437 82 233 31 786 234)

# for reg in 0.001
# do
#   for idx in {0..8}
#   do
#     seed1=${seed[($idx % 10)]}
#     seed2=${seed[(($idx+1) % 10)]}
#     opt='adam'
#     path="result/tlp_${opt}/rnn_256_mnist_split/layer_1/idenitity/"
#     mkdir -p ${path}
    
#     python ${SRC}/fuse_rnn_models.py \
#           --experiment_name test_fuse_01 \
#           --model_name 'RNN' \
#           --dataset_name "SplitMNIST" \
#           --nsplits 1 \
#           --split_index 1 \
#           --ds_scale_factor 1.0 \
#           --input_dim 28 \
#           --embed_dim 28 \
#           --hidden_dims [256] \
#           --output_dim 10 \
#           --batch_size 64 \
#           --num_epochs 20 \
#           --seed 43 \
#           --gpu_ids 0 \
#           --optimizer 'Adam' \
#           --fusion_type tlp \
#           --alpha_h 1000.0 1.0 \
#           --theta_pi 1.0 \
#           --num_pi_iters 50 \
#           --niters_rnn 20 \
#           --activation_batch_size 256 \
#           --tlp_cost_choice 'weight' \
#           --tlp_init_type 'identity' \
#           --tlp_init_model 0 \
#           --tlp_ot_solver sinkhorn \
#           --tlp_sinkhorn_regularization $reg \
#           --tlp_sinkhorn_regularization_list ${reg} ${reg} ${reg} \
#           --save_path "${path}" \
#           --result_name "models_${seed1}_${seed2}_reg_${reg}.pth" \
#           --model_path_list \
#           RNN,"./result/layer_1_dim_256_scale_1_adam/rnn_mnist/seed_${seed1}/best_val_acc_model.pth" \
#           RNN,"./result/layer_1_dim_256_scale_1_adam/rnn_mnist/seed_${seed2}/best_val_acc_model.pth"
#   done
# done


#### WB Fusion ####

# SRC='src/tlp_rnn_fusion'
# seed=(847 53 43 348 437 82 233 31 786 234)

# for reg in 0.001
# do
#   for idx in {0..8}
#   do
#     seed1=${seed[($idx % 10)]}
#     seed2=${seed[(($idx+1) % 10)]}
#     opt='adam'
#     path="result/tlp_no_hidden_${opt}/rnn_256_mnist_split/layer_1/idenitity/"
#     mkdir -p ${path}
    
#     python ${SRC}/fuse_rnn_models.py \
#           --experiment_name test_fuse_01 \
#           --model_name 'RNN' \
#           --dataset_name "SplitMNIST" \
#           --nsplits 1 \
#           --split_index 1 \
#           --ds_scale_factor 1.0 \
#           --input_dim 28 \
#           --embed_dim 28 \
#           --hidden_dims [256] \
#           --output_dim 10 \
#           --batch_size 64 \
#           --num_epochs 20 \
#           --seed 43 \
#           --gpu_ids 0 \
#           --optimizer 'Adam' \
#           --fusion_type tlp_no_hidden \
#           --alpha_h 1000.0 1.0 \
#           --theta_pi 1.0 \
#           --num_pi_iters 50 \
#           --niters_rnn 20 \
#           --activation_batch_size 256 \
#           --tlp_cost_choice 'weight' \
#           --tlp_init_type 'identity' \
#           --tlp_init_model 0 \
#           --tlp_ot_solver sinkhorn \
#           --tlp_sinkhorn_regularization $reg \
#           --tlp_sinkhorn_regularization_list ${reg} ${reg} ${reg} \
#           --save_path "${path}" \
#           --result_name "models_${seed1}_${seed2}_reg_${reg}.pth" \
#           --model_path_list \
#           RNN,"./result/layer_1_dim_256_scale_1_adam/rnn_mnist/seed_${seed1}/best_val_acc_model.pth" \
#           RNN,"./result/layer_1_dim_256_scale_1_adam/rnn_mnist/seed_${seed2}/best_val_acc_model.pth"
#   done
# done



#### OT Fusion ####

# SRC='src/tlp_rnn_fusion'
# seed=(847 53 43 348 437 82 233 31 786 234)
# for reg in 0.001
# do
#   for idx in {0..8}
#   do
#     seed1=${seed[($idx % 10)]}
#     seed2=${seed[(($idx+1) % 10)]}
#     opt='adam'
#     path="result/ot_${opt}/rnn_256_mnist_split/layer_1/idenitity/"
#     mkdir -p ${path}
    
#     python ${SRC}/fuse_rnn_models.py \
#           --experiment_name test_fuse_01 \
#           --model_name 'RNN' \
#           --dataset_name "SplitMNIST" \
#           --nsplits 1 \
#           --split_index 1 \
#           --ds_scale_factor 1.0 \
#           --input_dim 28 \
#           --embed_dim 28 \
#           --hidden_dims [256] \
#           --output_dim 10 \
#           --batch_size 64 \
#           --num_epochs 20 \
#           --seed 43 \
#           --gpu_ids 0 \
#           --optimizer 'Adam' \
#           --fusion_type ot \
#           --alpha_h 1000.0 1.0 \
#           --theta_pi 1.0 \
#           --num_pi_iters 20 \
#           --niters_rnn 200 \
#           --activation_batch_size 256 \
#           --ad_hoc_cost_choice 'weight' \
#           --ad_hoc_initialization 0 \
#           --ad_hoc_ot_solver sinkhorn \
#           --ad_hoc_sinkhorn_regularization $reg \
#           --save_path "${path}" \
#           --result_name "models_${seed1}_${seed2}_reg_${reg}.pth" \
#           --model_path_list \
#           RNN,"./result/layer_1_dim_256_scale_1_adam/rnn_mnist/seed_${seed1}/best_val_acc_model.pth" \
#           RNN,"./result/layer_1_dim_256_scale_1_adam/rnn_mnist/seed_${seed2}/best_val_acc_model.pth"
#   done
# done



#### Vanilla Averaging Fusion ####

# SRC='src/tlp_rnn_fusion'
# seed=(847 53 43 348 437 82 233 31 786 234)

# for idx in {0..8}
# do
#   seed1=${seed[($idx % 10)]}
#   seed2=${seed[(($idx+1) % 10)]}
#   opt='adam'
#   path="result/avg_${opt}/rnn_256_mnist_split/layer_1/idenitity/"
#   mkdir -p ${path}
  
#   python ${SRC}/fuse_rnn_models.py \
#         --experiment_name test_fuse_01 \
#         --model_name 'RNN' \
#         --dataset_name "SplitMNIST" \
#         --nsplits 1 \
#         --split_index 1 \
#         --ds_scale_factor 1.0 \
#         --input_dim 28 \
#         --embed_dim 28 \
#         --hidden_dims [256] \
#         --output_dim 10 \
#         --batch_size 64 \
#         --num_epochs 20 \
#         --seed 43 \
#         --gpu_ids 0 \
#         --optimizer 'Adam' \
#         --fusion_type avg \
#         --activation_batch_size 256 \
#         --save_path "${path}" \
#         --result_name "models_${seed1}_${seed2}.pth" \
#         --model_path_list \
#         RNN,"./result/layer_1_dim_256_scale_1_adam/rnn_mnist/seed_${seed1}/best_val_acc_model.pth" \
#         RNN,"./result/layer_1_dim_256_scale_1_adam/rnn_mnist/seed_${seed2}/best_val_acc_model.pth"
# done






################## Fusion of RNN base models trained on AGNEWS dataset ###################

#### GWB Fusion ####

# export PYTHONPATH=$PYTHONPATH:.
# SRC='src/tlp_rnn_fusion'
# seeds=(847 53 43 348 437 82 233 31 786 234)

# for reg in 0.005
#   do
#     for alpha_h in 100.0
#     do
#       for idx in {0..8}
#       do
#         seed1=${seeds[($idx % 10)]}
#         seed2=${seeds[(($idx+1) % 10)]}
#         opt='adam'
#         path="result/rnn_agnews_emb_100_dim_256_tlp_${alpha_h}/layer_1/idenitity/"
#         mkdir -p ${path}
        
#         python ${SRC}/fuse_rnn_models.py \
#               --experiment_name test_fuse_01 \
#               --model_name rnn \
#               --dataset_name "AG_NEWS" \
#               --train_data_path "data/ag_news_csv" \
#               --glove_path "data/custom_datasets/glove.6B.100d.txt" \
#               --input_dim 100 \
#               --embed_dim 100 \
#               --hidden_dims [256] \
#               --output_dim 4 \
#               --batch_size 64 \
#               --num_epochs 20 \
#               --seed 43 \
#               --gpu_ids 0 \
#               --fusion_type tlp \
#               --alpha_h ${alpha_h} 1.0 \
#               --theta_pi 1.0 \
#               --niters_rnn 200 \
#               --num_pi_iters 20 \
#               --activation_batch_size 256 \
#               --tlp_init_type 'identity' \
#               --tlp_cost_choice 'weight' \
#               --tlp_init_model 0 \
#               --tlp_ot_solver sinkhorn \
#               --tlp_sinkhorn_regularization $reg \
#               --tlp_sinkhorn_regularization_list ${reg} ${reg} \
#               --save_path "${path}" \
#               --result_name "models_${seed1}_${seed2}_reg_${reg}.pth" \
#               --model_path_list \
#               RNN,"./result/layer_1_emb_100_dim_256_${opt}/rnn_agnews/seed_${seed1}/best_val_acc_model.pth" \
#               RNN,"./result/layer_1_emb_100_dim_256_${opt}/rnn_agnews/seed_${seed2}/best_val_acc_model.pth"
#     done
#   done
# done


#### WB Fusion ####

# export PYTHONPATH=$PYTHONPATH:.
# SRC='src/tlp_rnn_fusion'
# seeds=(847 53 43 348 437 82 233 31 786 234)

# for reg in 0.005
#   do
#     for alpha_h in 100.0
#     do
#       for idx in {0..8}
#       do
#         seed1=${seeds[($idx % 10)]}
#         seed2=${seeds[(($idx+1) % 10)]}
#         opt='adam'
#         path="result/rnn_agnews_emb_100_dim_256_tlp_no_hidden/layer_1/idenitity/"
#         mkdir -p ${path}
        
#         python ${SRC}/fuse_rnn_models.py \
#               --experiment_name test_fuse_01 \
#               --model_name rnn \
#               --dataset_name "AG_NEWS" \
#               --train_data_path "data/ag_news_csv" \
#               --glove_path "data/custom_datasets/glove.6B.100d.txt" \
#               --input_dim 100 \
#               --embed_dim 100 \
#               --hidden_dims [256] \
#               --output_dim 4 \
#               --batch_size 64 \
#               --num_epochs 20 \
#               --seed 43 \
#               --gpu_ids 0 \
#               --fusion_type tlp_no_hidden \
#               --alpha_h ${alpha_h} 1.0 \
#               --theta_pi 1.0 \
#               --niters_rnn 200 \
#               --num_pi_iters 20 \
#               --activation_batch_size 256 \
#               --tlp_init_type 'identity' \
#               --tlp_cost_choice 'weight' \
#               --tlp_init_model 0 \
#               --tlp_ot_solver sinkhorn \
#               --tlp_sinkhorn_regularization $reg \
#               --tlp_sinkhorn_regularization_list ${reg} ${reg} \
#               --save_path "${path}" \
#               --result_name "models_${seed1}_${seed2}_reg_${reg}.pth" \
#               --model_path_list \
#               RNN,"./result/layer_1_emb_100_dim_256_${opt}/rnn_agnews/seed_${seed1}/best_val_acc_model.pth" \
#               RNN,"./result/layer_1_emb_100_dim_256_${opt}/rnn_agnews/seed_${seed2}/best_val_acc_model.pth"
#     done
#   done
# done



#### OT Fusion ####

# export PYTHONPATH=$PYTHONPATH:.
# SRC='src/tlp_rnn_fusion'
# seeds=(847 53 43 348 437 82 233 31 786 234)

# for reg in 0.005
#   do
#     for alpha_h in 100.0
#     do
#       for idx in {0..8}
#       do
#         seed1=${seeds[($idx % 10)]}
#         seed2=${seeds[(($idx+1) % 10)]}
#         opt='adam'
#         path="result/rnn_agnews_emb_100_dim_256_ot/layer_1/idenitity/"
#         mkdir -p ${path}
        
#         python ${SRC}/fuse_rnn_models.py \
#               --experiment_name test_fuse_01 \
#               --model_name rnn \
#               --dataset_name "AG_NEWS" \
#               --train_data_path "data/ag_news_csv" \
#               --glove_path "data/custom_datasets/glove.6B.100d.txt" \
#               --input_dim 100 \
#               --embed_dim 100 \
#               --hidden_dims [256] \
#               --output_dim 4 \
#               --batch_size 64 \
#               --num_epochs 20 \
#               --seed 43 \
#               --gpu_ids 0 \
#               --fusion_type ot \
#               --alpha_h ${alpha_h} 1.0 \
#               --theta_pi 1.0 \
#               --niters_rnn 200 \
#               --num_pi_iters 20 \
#               --activation_batch_size 256 \
#               --ad_hoc_cost_choice 'weight' \
#               --ad_hoc_initialization 0 \
#               --ad_hoc_ot_solver sinkhorn \
#               --ad_hoc_sinkhorn_regularization $reg \
#               --save_path "${path}" \
#               --result_name "models_${seed1}_${seed2}_reg_${reg}.pth" \
#               --model_path_list \
#               RNN,"./result/layer_1_emb_100_dim_256_${opt}/rnn_agnews/seed_${seed1}/best_val_acc_model.pth" \
#               RNN,"./result/layer_1_emb_100_dim_256_${opt}/rnn_agnews/seed_${seed2}/best_val_acc_model.pth"
#     done
#   done
# done



#### Vanilla Averaging Fusion ####

# export PYTHONPATH=$PYTHONPATH:.
# SRC='src/tlp_rnn_fusion'
# seeds=(847 53 43 348 437 82 233 31 786 234)

# for idx in {0..8}
# do
#   seed1=${seeds[($idx % 10)]}
#   seed2=${seeds[(($idx+1) % 10)]}
#   opt='adam'
#   path="result/rnn_agnews_emb_100_dim_256_avg/layer_1/idenitity/"
#   mkdir -p ${path}
  
#   python ${SRC}/fuse_rnn_models.py \
#         --experiment_name test_fuse_01 \
#         --model_name rnn \
#         --dataset_name "AG_NEWS" \
#         --train_data_path "data/ag_news_csv" \
#         --glove_path "data/custom_datasets/glove.6B.100d.txt" \
#         --input_dim 100 \
#         --embed_dim 100 \
#         --hidden_dims [256] \
#         --output_dim 4 \
#         --batch_size 64 \
#         --num_epochs 20 \
#         --seed 43 \
#         --gpu_ids 0 \
#         --fusion_type avg \
#         --save_path "${path}" \
#         --result_name "models_${seed1}_${seed2}.pth" \
#         --model_path_list \
#         RNN,"./result/layer_1_emb_100_dim_256_${opt}/rnn_agnews/seed_${seed1}/best_val_acc_model.pth" \
#         RNN,"./result/layer_1_emb_100_dim_256_${opt}/rnn_agnews/seed_${seed2}/best_val_acc_model.pth"
# done




################## Fusion of RNN base models trained on DBpedia dataset ###################


#### GWB Fusion ####

# export PYTHONPATH=$PYTHONPATH:.
# SRC='src/tlp_rnn_fusion'
# seeds=(847 53 43 348 437 82 233 31 786 234)

# for reg in 0.005
#   do
#     for alpha_h in 1000.0
#     do
#       for idx in {0..8}
#       do
#         seed1=${seeds[($idx % 10)]}
#         seed2=${seeds[(($idx+1) % 10)]}
#         opt='adam'
#         path="result/rnn_dbpedia_emb_100_dim_256_tlp_${alpha_h}/layer_1/idenitity/"
#         mkdir -p ${path}
        
#         python ${SRC}/fuse_rnn_models.py \
#               --experiment_name test_fuse_01 \
#               --model_name rnn \
#               --dataset_name "DBpedia" \
#               --train_data_path "data/dbpedia_csv" \
#               --glove_path "data/custom_datasets/glove.6B.100d.txt" \
#               --input_dim 100 \
#               --embed_dim 100 \
#               --hidden_dims [256] \
#               --output_dim 14 \
#               --batch_size 64 \
#               --num_epochs 20 \
#               --seed 43 \
#               --gpu_ids 0 \
#               --fusion_type tlp \
#               --alpha_h ${alpha_h} 1.0 \
#               --theta_pi 1.0 \
#               --niters_rnn 200 \
#               --num_pi_iters 20 \
#               --activation_batch_size 256 \
#               --tlp_init_type 'identity' \
#               --tlp_cost_choice 'weight' \
#               --tlp_init_model 0 \
#               --tlp_ot_solver sinkhorn \
#               --tlp_sinkhorn_regularization $reg \
#               --tlp_sinkhorn_regularization_list ${reg} ${reg} \
#               --save_path "${path}" \
#               --result_name "models_${seed1}_${seed2}_reg_${reg}.pth" \
#               --model_path_list \
#               RNN,"./result/layer_1_emb_100_dim_256_${opt}/rnn_dbpedia/seed_${seed1}/best_val_acc_model.pth" \
#               RNN,"./result/layer_1_emb_100_dim_256_${opt}/rnn_dbpedia/seed_${seed2}/best_val_acc_model.pth"
#     done
#   done
# done



#### GWB Fusion ####

# export PYTHONPATH=$PYTHONPATH:.
# SRC='src/tlp_rnn_fusion'
# seeds=(847 53 43 348 437 82 233 31 786 234)

# for reg in 0.005
#   do
#     for alpha_h in 1000.0
#     do
#       for idx in {0..8}
#       do
#         seed1=${seeds[($idx % 10)]}
#         seed2=${seeds[(($idx+1) % 10)]}
#         opt='adam'
#         path="result/rnn_dbpedia_emb_100_dim_256_tlp_${alpha_h}/layer_1/idenitity/"
#         mkdir -p ${path}
        
#         python ${SRC}/fuse_rnn_models.py \
#               --experiment_name test_fuse_01 \
#               --model_name rnn \
#               --dataset_name "DBpedia" \
#               --train_data_path "data/dbpedia_csv" \
#               --glove_path "data/custom_datasets/glove.6B.100d.txt" \
#               --input_dim 100 \
#               --embed_dim 100 \
#               --hidden_dims [256] \
#               --output_dim 14 \
#               --batch_size 64 \
#               --num_epochs 20 \
#               --seed 43 \
#               --gpu_ids 0 \
#               --fusion_type tlp \
#               --alpha_h ${alpha_h} 1.0 \
#               --theta_pi 1.0 \
#               --niters_rnn 200 \
#               --num_pi_iters 20 \
#               --activation_batch_size 256 \
#               --tlp_init_type 'identity' \
#               --tlp_cost_choice 'weight' \
#               --tlp_init_model 0 \
#               --tlp_ot_solver sinkhorn \
#               --tlp_sinkhorn_regularization $reg \
#               --tlp_sinkhorn_regularization_list ${reg} ${reg} \
#               --save_path "${path}" \
#               --result_name "models_${seed1}_${seed2}_reg_${reg}.pth" \
#               --model_path_list \
#               RNN,"./result/layer_1_emb_100_dim_256_${opt}/rnn_dbpedia/seed_${seed1}/best_val_acc_model.pth" \
#               RNN,"./result/layer_1_emb_100_dim_256_${opt}/rnn_dbpedia/seed_${seed2}/best_val_acc_model.pth"
#     done
#   done
# done



#### WB Fusion ####

# export PYTHONPATH=$PYTHONPATH:.
# SRC='src/tlp_rnn_fusion'
# seeds=(847 53 43 348 437 82 233 31 786 234)

# for reg in 0.005
#   do
#     for alpha_h in 1000.0
#     do
#       for idx in {0..8}
#       do
#         seed1=${seeds[($idx % 10)]}
#         seed2=${seeds[(($idx+1) % 10)]}
#         opt='adam'
#         path="result/rnn_dbpedia_emb_100_dim_256_tlp_no_hidden/layer_1/idenitity/"
#         mkdir -p ${path}
        
#         python ${SRC}/fuse_rnn_models.py \
#               --experiment_name test_fuse_01 \
#               --model_name rnn \
#               --dataset_name "DBpedia" \
#               --train_data_path "data/dbpedia_csv" \
#               --glove_path "data/custom_datasets/glove.6B.100d.txt" \
#               --input_dim 100 \
#               --embed_dim 100 \
#               --hidden_dims [256] \
#               --output_dim 14 \
#               --batch_size 64 \
#               --num_epochs 20 \
#               --seed 43 \
#               --gpu_ids 0 \
#               --fusion_type tlp_no_hidden \
#               --alpha_h ${alpha_h} 1.0 \
#               --theta_pi 1.0 \
#               --niters_rnn 200 \
#               --num_pi_iters 20 \
#               --activation_batch_size 256 \
#               --tlp_init_type 'identity' \
#               --tlp_cost_choice 'weight' \
#               --tlp_init_model 0 \
#               --tlp_ot_solver sinkhorn \
#               --tlp_sinkhorn_regularization $reg \
#               --tlp_sinkhorn_regularization_list ${reg} ${reg} \
#               --save_path "${path}" \
#               --result_name "models_${seed1}_${seed2}_reg_${reg}.pth" \
#               --model_path_list \
#               RNN,"./result/layer_1_emb_100_dim_256_${opt}/rnn_dbpedia/seed_${seed1}/best_val_acc_model.pth" \
#               RNN,"./result/layer_1_emb_100_dim_256_${opt}/rnn_dbpedia/seed_${seed2}/best_val_acc_model.pth"
#     done
#   done
# done



#### OT Fusion ####

# export PYTHONPATH=$PYTHONPATH:.
# SRC='src/tlp_rnn_fusion'
# seeds=(847 53 43 348 437 82 233 31 786 234)

# for reg in 0.005
#   do
#     for alpha_h in 1000.0
#     do
#       for idx in {0..8}
#       do
#         seed1=${seeds[($idx % 10)]}
#         seed2=${seeds[(($idx+1) % 10)]}
#         opt='adam'
#         path="result/rnn_dbpedia_emb_100_dim_256_ot/layer_1/idenitity/"
#         mkdir -p ${path}
        
#         python ${SRC}/fuse_rnn_models.py \
#               --experiment_name test_fuse_01 \
#               --model_name rnn \
#               --dataset_name "DBpedia" \
#               --train_data_path "data/dbpedia_csv" \
#               --glove_path "data/custom_datasets/glove.6B.100d.txt" \
#               --input_dim 100 \
#               --embed_dim 100 \
#               --hidden_dims [256] \
#               --output_dim 14 \
#               --batch_size 64 \
#               --num_epochs 20 \
#               --seed 43 \
#               --gpu_ids 0 \
#               --fusion_type ot \
#               --alpha_h ${alpha_h} 1.0 \
#               --theta_pi 1.0 \
#               --niters_rnn 200 \
#               --num_pi_iters 20 \
#               --activation_batch_size 256 \
#               --ad_hoc_cost_choice 'weight' \
#               --ad_hoc_initialization 0 \
#               --ad_hoc_ot_solver sinkhorn \
#               --ad_hoc_sinkhorn_regularization $reg \
#               --save_path "${path}" \
#               --result_name "models_${seed1}_${seed2}_reg_${reg}.pth" \
#               --model_path_list \
#               RNN,"./result/layer_1_emb_100_dim_256_${opt}/rnn_dbpedia/seed_${seed1}/best_val_acc_model.pth" \
#               RNN,"./result/layer_1_emb_100_dim_256_${opt}/rnn_dbpedia/seed_${seed2}/best_val_acc_model.pth"
#     done
#   done
# done



#### Vanilla Averaging Fusion ####

# export PYTHONPATH=$PYTHONPATH:.
# SRC='src/tlp_rnn_fusion'
# seeds=(847 53 43 348 437 82 233 31 786 234)

# for idx in {0..8}
# do
#   seed1=${seeds[($idx % 10)]}
#   seed2=${seeds[(($idx+1) % 10)]}
#   opt='adam'
#   path="result/rnn_dbpedia_emb_100_dim_256_avg/layer_1/idenitity/"
#   mkdir -p ${path}
  
#   python ${SRC}/fuse_rnn_models.py \
#         --experiment_name test_fuse_01 \
#         --model_name rnn \
#         --dataset_name "DBpedia" \
#         --train_data_path "data/dbpedia_csv" \
#         --glove_path "data/custom_datasets/glove.6B.100d.txt" \
#         --input_dim 100 \
#         --embed_dim 100 \
#         --hidden_dims [256] \
#         --output_dim 14 \
#         --batch_size 64 \
#         --num_epochs 20 \
#         --seed 43 \
#         --gpu_ids 0 \
#         --fusion_type avg \
#         --save_path "${path}" \
#         --result_name "models_${seed1}_${seed2}.pth" \
#         --model_path_list \
#         RNN,"./result/layer_1_emb_100_dim_256_${opt}/rnn_dbpedia/seed_${seed1}/best_val_acc_model.pth" \
#         RNN,"./result/layer_1_emb_100_dim_256_${opt}/rnn_dbpedia/seed_${seed2}/best_val_acc_model.pth"
# done




################## Fusion of RNN base models trained on SST dataset ###################

#### GWB Fusion ####

# export PYTHONPATH=$PYTHONPATH:.
# SRC='src/tlp_rnn_fusion'
# seeds=(847 53 43 348 437 82 233 31 786 234)

# for idx in {0..8}
# do
#   seed1=${seeds[($idx % 10)]}
#   seed2=${seeds[(($idx+1) % 10)]}
#   opt='adam'
#   for reg in 0.005 
#   do
#     for alpha_h in 100.0
#     do
#       path="result/rnn_sst_emb_100_dim_256_tlp_${alpha_h}/layer_1/idenitity/"
#       mkdir -p ${path}
      
#       python ${SRC}/fuse_rnn_models.py \
#             --experiment_name test_fuse_01 \
#             --model_name rnn \
#             --dataset_name "SSTPT" \
#             --nsplits 1 \
#             --split_index 1 \
#             --ds_scale_factor 1.0 \
#             --glove_path "data/custom_datasets/glove.6B.100d.txt" \
#             --input_dim 100 \
#             --embed_dim 100 \
#             --hidden_dims [256] \
#             --output_dim 2 \
#             --batch_size 64 \
#             --num_epochs 20 \
#             --seed 43 \
#             --gpu_ids 0 \
#             --fusion_type tlp \
#             --alpha_h ${alpha_h} 1.0 \
#             --theta_pi 1.0 \
#             --niters_rnn 200 \
#             --num_pi_iters 20 \
#             --activation_batch_size 256 \
#             --tlp_init_type 'identity' \
#             --tlp_cost_choice 'weight' \
#             --tlp_init_model 0 \
#             --tlp_ot_solver sinkhorn \
#             --tlp_sinkhorn_regularization $reg \
#             --tlp_sinkhorn_regularization_list ${reg} ${reg} \
#             --save_path "${path}" \
#             --result_name "models_${seed1}_${seed2}_reg_${reg}.pth" \
#             --model_path_list \
#             RNN,"./result/layer_1_emb_100_dim_256_${opt}/rnn_sst/seed_${seed1}/best_val_acc_model.pth" \
#             RNN,"./result/layer_1_emb_100_dim_256_${opt}/rnn_sst/seed_${seed2}/best_val_acc_model.pth"
#     done
#   done
# done



#### WB Fusion ####

# export PYTHONPATH=$PYTHONPATH:.
# SRC='src/tlp_rnn_fusion'
# seeds=(847 53 43 348 437 82 233 31 786 234)

# for idx in {0..8}
# do
#   seed1=${seeds[($idx % 10)]}
#   seed2=${seeds[(($idx+1) % 10)]}
#   opt='adam'
#   for reg in 0.005 
#   do
#     for alpha_h in 100.0
#     do
#       path="result/rnn_sst_emb_100_dim_256_tlp_no_hidden/layer_1/idenitity/"
#       mkdir -p ${path}
      
#       python ${SRC}/fuse_rnn_models.py \
#             --experiment_name test_fuse_01 \
#             --model_name rnn \
#             --dataset_name "SSTPT" \
#             --nsplits 1 \
#             --split_index 1 \
#             --ds_scale_factor 1.0 \
#             --glove_path "data/custom_datasets/glove.6B.100d.txt" \
#             --input_dim 100 \
#             --embed_dim 100 \
#             --hidden_dims [256] \
#             --output_dim 2 \
#             --batch_size 64 \
#             --num_epochs 20 \
#             --seed 43 \
#             --gpu_ids 0 \
#             --fusion_type tlp_no_hidden \
#             --alpha_h ${alpha_h} 1.0 \
#             --theta_pi 1.0 \
#             --niters_rnn 200 \
#             --num_pi_iters 20 \
#             --activation_batch_size 256 \
#             --tlp_init_type 'identity' \
#             --tlp_cost_choice 'weight' \
#             --tlp_init_model 0 \
#             --tlp_ot_solver sinkhorn \
#             --tlp_sinkhorn_regularization $reg \
#             --tlp_sinkhorn_regularization_list ${reg} ${reg} \
#             --save_path "${path}" \
#             --result_name "models_${seed1}_${seed2}_reg_${reg}.pth" \
#             --model_path_list \
#             RNN,"./result/layer_1_emb_100_dim_256_${opt}/rnn_sst/seed_${seed1}/best_val_acc_model.pth" \
#             RNN,"./result/layer_1_emb_100_dim_256_${opt}/rnn_sst/seed_${seed2}/best_val_acc_model.pth"
#     done
#   done
# done



#### OT Fusion ####

# export PYTHONPATH=$PYTHONPATH:.
# SRC='src/tlp_rnn_fusion'
# seeds=(847 53 43 348 437 82 233 31 786 234)

# for idx in {0..8}
# do
#   seed1=${seeds[($idx % 10)]}
#   seed2=${seeds[(($idx+1) % 10)]}
#   opt='adam'
#   for reg in 0.005 
#   do
#     for alpha_h in 100.0
#     do
#       path="result/rnn_sst_emb_100_dim_256_ot/layer_1/idenitity/"
#       mkdir -p ${path}
      
#       python ${SRC}/fuse_rnn_models.py \
#             --experiment_name test_fuse_01 \
#             --model_name rnn \
#             --dataset_name "SSTPT" \
#             --nsplits 1 \
#             --split_index 1 \
#             --ds_scale_factor 1.0 \
#             --glove_path "data/custom_datasets/glove.6B.100d.txt" \
#             --input_dim 100 \
#             --embed_dim 100 \
#             --hidden_dims [256] \
#             --output_dim 2 \
#             --batch_size 64 \
#             --num_epochs 20 \
#             --seed 43 \
#             --gpu_ids 0 \
#             --fusion_type ot \
#             --alpha_h ${alpha_h} 1.0 \
#             --theta_pi 1.0 \
#             --niters_rnn 200 \
#             --num_pi_iters 20 \
#             --activation_batch_size 256 \
#             --ad_hoc_cost_choice 'weight' \
#             --ad_hoc_initialization 0 \
#             --ad_hoc_ot_solver sinkhorn \
#             --ad_hoc_sinkhorn_regularization $reg \
#             --save_path "${path}" \
#             --result_name "models_${seed1}_${seed2}_reg_${reg}.pth" \
#             --model_path_list \
#             RNN,"./result/layer_1_emb_100_dim_256_${opt}/rnn_sst/seed_${seed1}/best_val_acc_model.pth" \
#             RNN,"./result/layer_1_emb_100_dim_256_${opt}/rnn_sst/seed_${seed2}/best_val_acc_model.pth"
#     done
#   done
# done



#### Vanilla Averaging Fusion ####

# export PYTHONPATH=$PYTHONPATH:.
# SRC='src/tlp_rnn_fusion'
# seeds=(847 53 43 348 437 82 233 31 786 234)

# for idx in {0..8}
# do
#   seed1=${seeds[($idx % 10)]}
#   seed2=${seeds[(($idx+1) % 10)]}
#   opt='adam'
 
#   path="result/rnn_sst_emb_100_dim_256_avg/layer_1/idenitity/"
#   mkdir -p ${path}
  
#   python ${SRC}/fuse_rnn_models.py \
#         --experiment_name test_fuse_01 \
#         --model_name rnn \
#         --dataset_name "SSTPT" \
#         --nsplits 1 \
#         --split_index 1 \
#         --ds_scale_factor 1.0 \
#         --glove_path "data/custom_datasets/glove.6B.100d.txt" \
#         --input_dim 100 \
#         --embed_dim 100 \
#         --hidden_dims [256] \
#         --output_dim 2 \
#         --batch_size 64 \
#         --num_epochs 20 \
#         --seed 43 \
#         --gpu_ids 0 \
#         --fusion_type avg \
#         --save_path "${path}" \
#         --result_name "models_${seed1}_${seed2}.pth" \
#         --model_path_list \
#         RNN,"./result/layer_1_emb_100_dim_256_${opt}/rnn_sst/seed_${seed1}/best_val_acc_model.pth" \
#         RNN,"./result/layer_1_emb_100_dim_256_${opt}/rnn_sst/seed_${seed2}/best_val_acc_model.pth"
# done













